// Telegrammer - Telegram Bot Swift SDK.
// This file is autogenerated by API/generate_wrappers.rb script.


import HTTP

public extension Bot {

    /// Use this method to delete a sticker from a set created by the bot. Returns True on success.
    /// - Parameters:
    ///     - sticker: File identifier of the sticker
    /// - Returns: Future<Bool>. Throws on errors.
    /// - Note: Asynchronous method.
    ///
    /// [- SeeAlso: ]<https://core.telegram.org/bots/api#deletestickerfromset>

    public struct DeleteStickerFromSetParams: JSONEncodable {
        var sticker: String

        enum CodingKeys: String, CodingKey {
            case sticker = "sticker"
        }

        public init(sticker: String) {
            self.sticker = sticker
        }
    }

    @discardableResult
    public func deleteStickerFromSet(params: DeleteStickerFromSetParams) throws -> Future<Bool> {
        let body = try httpBody(for: params)
        let headers = httpHeaders(for: params)
        let response: Future<TelegramContainer<Bool>>
        response = try client.respond(endpoint: "deleteStickerFromSet", body: body, headers: headers)
        return response.flatMap(to: Bool.self) { try self.wrap($0) }
    }
}
